# ===== マンカラ（人対人）============================================================

import tkinter
import time 

start1=2      # スタート時の皿の番号（0,--,5)
start2=2
x0=0       # スタート時の石の個数 x0=[start1] or [start2]
index=0
tmr=0
key=""
jun=1       # 順番 1 or 2
ind=0       # どちらかが勝利で１
kazu_1=[0,0,0,0,0,0,0]   # 0,--,5 ,6              [0] [1] [2] [3] [4] [5] [6]=pkt_r
kazu_2=[0,0,0,0,0,0,0]   # 0,--,5 ,6    pkt_l=[6] [5] [4] [3] [2] [1] [0]

# ------------------------------------------------------------------------------------

def key_down(e):        # Key Down
    global key
    key=e.keysym
def key_up(e):          # Key Up
    global key
    key=""

def draw_kazu():      # 現在のkazuリストのデータで全て表示
    cvs.delete("KAZU")
    for x in range(0,6):    # kazu_1[*]: * * * * * * (0,--,5)
        cvs.create_image(x*150+220,220,image=img_kazu[kazu_1[x]],tag="KAZU")
    draw_text(str(kazu_1[6]),1110,315,25,"blue","KAZU")     # 右箱 kazu_1[6]
    for x in range(0,6):    # kazu_2[*]: * * * *`* * (5,--,0)
       cvs.create_image(x*150+220,420,image=img_kazu[kazu_2[5-x]],tag="KAZU")
    draw_text(str(kazu_2[6]),80,315,25,"blue","KAZU")       # 左箱 kazu_2[6]

def draw_text(txt,x,y,siz,col,tg):      # テキスト表示（影付き）
    fnt=("Times New Roman",siz,"bold")
#    cvs.create_text(x+3,y+3,text=txt,fill="black",font=fnt,tag=tg)
    cvs.create_text(x,y,text=txt,fill=col,font=fnt,tag=tg)
#    draw_text("↑",300,230,30,"red","YA")    

    

def teban_1():      # ------------------ 手番１ -----------------------------
    global start1,x0
    cvs.delete("YA")
    if key=="Left" and start1>=1:   # strt:スタート時の皿の番号 (0,--,5)
        start1-=1
    if key=="Right" and start1<=4:
        start1+=1
    if key=="Up":
        cvs.delete("HIT")
        cvs.delete("YA")
        x0=kazu_1[start1]    # strt:0,--,5    stx:皿に入っていた石の個数
        if x0>0:
            kazu_1[start1]=0      # スタートした皿を空にする
            koma_idou1()        # 駒移動の関数
        else:
            jun=1   # 個数 0 の皿を↓するとやり直し
    draw_text("↑",220+150*start1,268,40,"white","YA")     

def koma_idou1():   # 手番１の駒の移動 -----
    global start1,x0,jun,ind,tmr
    if x0>13-start1:
        for x in range(start1+1,7):
            kazu_1[x]+=1
        for x in range(0,7):
            kazu_2[x]+=1
        for x in range(0,x0+start1-13):
            kazu_1[x]+=1
    else:    
        if x0>6-start1:
            for x in range(start1+1,7):
                kazu_1[x]+=1
            for x in range(0,x0+start1-6):
                kazu_2[x]+=1
        else:
            for x in range(start1+1,start1+x0+1):     # [
                kazu_1[x]+=1
    if kazu_1[0]+kazu_1[1]+kazu_1[2]+kazu_1[3]+kazu_1[4]+kazu_1[5]==0:
        draw_text("勝利！",300,150,40,"red","KATI")         # 表示「勝利！」
        ind=1
        tmr=0
    if kazu_1[0]>14 or kazu_1[1]>14 or kazu_1[2]>14 or kazu_1[3]>14 or kazu_1[4]>14 or kazu_1[5]>14:
        draw_text("負け",300,150,30,"white","KATI")          # 「負け」
        ind=1
        tmr=0
    if x0+start1==6 or x0+start1==13:
        draw_text("Hit!",600,170,25,"pink","HIT")         # 表示「ヒット！」
        jun=1
    else:
        jun=2
    cvs.delete("YA")

def teban_2():      # ---------------------- 手番２ -------------------------      
    global start2,x0
    cvs.delete("YA")
    if key=="Left" and start2>=1:     # strt:スタート時の皿の番号 (0,--,5)
        start2=start2-1
    if key=="Right" and start2<=4:
        start2=start2+1
    if key=="Down":
        cvs.delete("HIT")
        cvs.delete("YA")        
        start2=5-start2
        x0=kazu_2[start2]    # strt:0,--,5    stx:皿に入っていた石の個数
        if x0>0:
            kazu_2[start2]=0      # スタートした皿を空にする
            koma_idou2()
        else:
            jun=2   # 個数 0 の皿を↓するとやり直し
        cvs.delete("YA")    
    draw_text("↓",220+150*start2,370,40,"white","YA")

def koma_idou2():   # 手番２の駒の移動 -----
    global start2,x0,jun,ind,tmr
    jun=1
    if x0>13-start2:
        for x in range(start2+1,7):
            kazu_2[x]=kazu_2[x]+1
        for x in range(0,7):
            kazu_1[x]=kazu_1[x]+1
        for x in range(0,x0+start2-13):
            kazu_2[x]=kazu_2[x]+1           
    else:    
        if x0>6-start2:
            for x in range(start2+1,7):
                kazu_2[x]=kazu_2[x]+1
            for x in range(0,x0+start2-6):
                kazu_1[x]=kazu_1[x]+1
        else:
            for x in range(start2+1,start2+x0+1):     # [
                kazu_2[x]=kazu_2[x]+1
    start2=5-start2
    if kazu_2[0]+kazu_2[1]+kazu_2[2]+kazu_2[3]+kazu_2[4]+kazu_2[5]==0:
        draw_text("勝利！",300,500,40,"red","KATI")         # 表示「勝利！」
        ind=1
        tmr=0
    if kazu_2[0]>14 or kazu_2[1]>14 or kazu_2[2]>14 or kazu_2[3]>14 or kazu_2[4]>14 or kazu_2[5]>14:
        draw_text("負け",300,500,30,"white","KATI")          # 「負け」
        ind=1
        tmr=0
    if x0+5-start2==6 or x0+5-start2==13:
        draw_text("Hit!",600,480,25,"pink","HIT")         # 表示「ヒット！」        
        jun=2
    else:
        jun=1
    cvs.delete("YA")    


def main_proc(): # ====================================================================
    global index,tmr,jun,x0,kazu_1,kazu_2,ind,start1,start2
    if index==0:
        cvs.create_rectangle(140,200,1050,250,fill="black")     # 黒い帯＿上
        cvs.create_rectangle(140,400,1050,450,fill="black")
        cvs.create_image(80,320,image=img_hako2,tag="HAKO")    # 黒い箱＿左
        cvs.create_image(1110,320,image=img_hako2,tag="HAKO")
        draw_kazu()
        if tmr>=15:
            tmr=0
            cvs.delete("HIT")
            cvs.delete("KATI")
            cvs.delete("YA")           
            jun=1
            ind=0
            start1=2
            start2=2     
            kazu_1=[4,4,4,4,4,4,0]
            kazu_2=[4,4,4,4,4,4,0]
            draw_kazu()
            index=1
    elif index==1:      # --- 手番１ --------------------------
        teban_1()
        draw_kazu()
        if ind==1:      # １の勝利で、ind=1
            index=0
        else:           # まだ勝負がつかなければ
            if jun==2:  # 関数内で、手番の交替済み（jun=1 => jun=2）になっている
                index=2
    elif index==2:      # --- 手番２ --------------------------
        teban_2()
        draw_kazu()
        if ind==1:      # ２の勝利で、ind=1
            index=0
        else:
            if jun==1:
                index=1
    tmr=tmr+1
    root.after(230,main_proc)       # root.after 300
# =====================================================================================
    
root=tkinter.Tk()                       # root=tkinter.Tk()
root.title("マンカラ")
root.bind("<KeyPress>",key_down)        # key_down
root.bind("<KeyRelease>",key_up)        # key_up
cvs=tkinter.Canvas(width=1200,height=650,bg="green")    # Canvas: 1200x650 => cvs
draw_text("マンカラ",600,50,45,"yellow","TITLE")         # タイトル表示「マンカラ」
img_hako2=tkinter.PhotoImage(file="hako_2.png")
draw_text("＞＞＞",990,170,30,"yellow","a")
draw_text("＜＜＜",200,480,30,"yellow","a")
cvs.pack()                
        
img_kazu=[
    tkinter.PhotoImage(file="man_0.png"),  
    tkinter.PhotoImage(file="man_1.png"),  
    tkinter.PhotoImage(file="man_2.png"),  
    tkinter.PhotoImage(file="man_3.png"),
    tkinter.PhotoImage(file="man_4.png"),
    tkinter.PhotoImage(file="man_5.png"),
    tkinter.PhotoImage(file="man_6.png"),
    tkinter.PhotoImage(file="man_7.png"),
    tkinter.PhotoImage(file="man_8.png"),
    tkinter.PhotoImage(file="man_9.png"),
    tkinter.PhotoImage(file="man_10.png"),
    tkinter.PhotoImage(file="man_11.png"),
    tkinter.PhotoImage(file="man_12.png"),
    tkinter.PhotoImage(file="man_13.png"),
    tkinter.PhotoImage(file="man_14.png"),
    tkinter.PhotoImage(file="man_15.png")    
]

main_proc()
root.mainloop()

